
/*
	Copyright 2001-2004 Georges Menie (www.menie.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _BASELIB_H_
#define _BASELIB_H_

#ifndef NULL
#define NULL 0
#endif

extern int printf (const char *, ...);
extern int sprintf (char *, const char *, ...);
extern int putchar (int);
extern int getchar (void);

extern int memcmp (const void *, const void *, unsigned long);
extern void *memcpy (void *, const void *, unsigned long);
extern void *memset (void *, int, unsigned long);
extern char *strchr (const char *, int);
extern int strcmp (const char *d, const char *s);
extern char *strcpy (char *d, const char *s);
extern unsigned long strlen (const char *str);

extern void _outbyte (int);
extern int _inbyte (unsigned short);
extern void jump (void *);

void srand(unsigned int);	/* seed the generator */
unsigned int rand(void);	/* returns a random 32-bit integer */

#endif
