
/*
	Copyright 2001-2004 Georges Menie (www.menie.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "baselib.h"
#include "68vz328.h"
#include "io.h"
#include "timer.h"

int _inbyte(unsigned short timeout) // msec timeout
{
	unsigned short c;
	int delay = timeout << 4;

	while (((c=readw(URX1)) & 0x2000) == 0) {
		usleep(60); // 60 us * 16 = 960 us (~ 1 ms)
		if (timeout) {
			if (--delay == 0) return -2;
		}
	}

	return c & 0x0FF;
}
