
/*
	Copyright 2001-2004 Georges Menie (www.menie.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "baselib.h"

void *memcpy (void *dst, const void *src, unsigned long len)
{
	if ((((long)dst) & 1) ^ (((long)src) & 1)) {
		while (len) {
			*((char *)dst)++ = *((char *)src)++;
			--len;
		}
		return;
	}

	if (((long)dst) & 1) {
		*((char *)dst)++ = *((char *)src)++;
		--len;
	}

	while (len >= 4) {
		*((long *)dst)++ = *((long *)src)++;
		len -= 4;
	}

	while (len) {
		*((char *)dst)++ = *((char *)src)++;
		--len;
	}

	return dst;
}
