
/*
	Copyright 2001-2004 Georges Menie (www.menie.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "timer.h"
#include "68vz328.h"
#include "io.h"

/* initialize the processor's timer register
 * on a 33MHz 68vz328 board, this initialize a 1us resolution timer
 */
void timerInit (void)
{
	/* disable Timer 1 */
	writew (0, TCTL1);

	/* init Timer 1 */
	writew ((1 << 8) | (1 << 1), TCTL1);	/* Free running, SYSCLK, no IRQ */
	writew (33, TPRER1);		/* -> 1 us ticks */

	/* enable Timer 1 */
	orw (1, TCTL1);
}
