STARTUP(crt0.o)
OUTPUT_ARCH(m68k)
SEARCH_DIR(.)
GROUP(-lgcc)
__DYNAMIC  =  0;

MEMORY
{
  sdram (rwx) : ORIGIN = 0x1000, LENGTH = 64k - 4k
  flash (rx) : ORIGIN = 0x04010000, LENGTH = 2M - 64k
}

PROVIDE (__stack = 64k - 8);

SECTIONS
{
  .text :
  {
    __text_start = .;
    *(.text)

    . = ALIGN(0x4);
    *(.rodata)

    . = ALIGN(0x4);
    *(.gcc_except_table) 

    . = ALIGN(0x4);
    *(.eh_frame)

    . = ALIGN(0x4);
    *(.lit)

    . = ALIGN(0x4);
    __text_end = .;
  } > flash

  .data : AT (__text_end) 
   {
    . = ALIGN (0x4);
    __data_start = .;

    *(.shdata)
    *(.data)
    *(.gcc_exc)

    . = ALIGN (0x4);
    __data_end = .;
   } > sdram

  .bss :
  {
    . = ALIGN(0x4);
    __bss_start = . ;

    *(.shbss)
    *(.bss)
    *(COMMON)

    . = ALIGN(0x4);
    __bss_end = .;
    _end = .;
  } > sdram

  .stab 0 (NOLOAD) :
  {
    *(.stab)
  }

  .stabstr 0 (NOLOAD) :
  {
    *(.stabstr)
  }
}
